# JET Audit Framework - @oracle/oraclejet-audit

## About JET Audit Framework

Oracle JET audits run against the application files of your JET project and perform a static analysis of the source code from an Oracle JET perspective. Audit messages result from an invocation of the Oracle JET Audit Framework (JAF) command-line utility and are governed by rules that are specific to a JET release version. As such, you can update the framework installation for a new Oracle JET release or configure the Oracle JAF audit for a previous release.

With Oracle JAF installed, audits that you perform against your Oracle JET application run in a Command-Line Interface, similar to the Oracle JET CLI. The installation of JAF provides a lint-style command-line utility named "ojaf" that audits JET application files (currently HTML, JS, CSS, and JSON) by applying rules that perform a static analysis from an Oracle JET perspective. The audit messages returned by invocation of the "ojaf" utility result from a rule set that is specific to the Oracle JET release version of the application. As new versions of Oracle JET are released, Oracle JAF
and the applicable rules may be updated. For this reason, you will want to update JAF regularly.

Please see the [JET Audit Framework](http://www.oracle.com/pls/topic/lookup?ctx=jetlatest&id=ojaf) for details.

## Installation
For web app development, install this module as follows:

```
npm install -g @oracle/oraclejet-audit
```
