/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const CaccHelpers=require("./jetwco-cacc-helpers");function controlCallback(controlRuleName,controlRuleDef,semver,cacheManager,metadata,compareMetadata,componentVersionDiff,baselines,componentType,componentName,errorMsgContext,overrideTypeMappings){let errorConditions=[];if(componentType==="composite"){const{add:addConstraint,remove:removeConstraint}=controlRuleDef;const diffs=CaccHelpers.mapAttributesDiff(metadata.properties,compareMetadata.properties,"required",true);if(CaccHelpers.checkConstraintMinorMajor(diffs.add,addConstraint,componentVersionDiff)){errorConditions.push(`Property required value set on ${diffs.add.map(addition=>addition.name).join(", ")} in${errorMsgContext}'${addConstraint}'`)}if(CaccHelpers.checkConstraintPatchMajor(diffs.remove,removeConstraint,componentVersionDiff)){errorConditions.push(`Property required value unset from ${diffs.remove.map(removal=>removal.name).join(", ")} in${errorMsgContext}'${removeConstraint}'`)}if(errorConditions.length>0){return errorConditions.join("\n")}}return};module.exports=controlCallback;