/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const RULE_NAME="ojc-acc-avatar-aria-role";const SHORT="The 'role' attribute should not be set on &lt;oj-c-avatar&gt;";const LONG="The 'role' attribute should not be set on &lt;oj-c-avatar&gt;. If the component needs to be accessible, "+"set the 'aria-label' or 'aria-labelledby' attribute and &lt;oj-c-avatar&gt; will internally set "+"role=\"img\". Otherwise, no 'role' attribute is needed.";const ROLE="role";function getName(){return RULE_NAME}function getShortDescription(){return SHORT}function getDescription(){return LONG}function register(){return{"<oj-c-avatar>":_onTag}}function _onTag(ruleCtx){var DomUtils=ruleCtx.utils.DomUtils;if(DomUtils.hasAttrib(ruleCtx.node,ROLE)){let issue=new ruleCtx.Issue("The 'role' attribute should not be specified on <oj-c-avatar>");let attrPos=DomUtils.getAttribPosition(ruleCtx.data,ruleCtx.node,"role");issue.setPosition(attrPos.row,attrPos.col,attrPos.start,attrPos.end);ruleCtx.reporter.addIssue(issue,ruleCtx)}}module.exports={getName,getDescription,getShortDescription,register};