/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const RULENAME="oj-acc-aria-ojselector-labelledby";const DESCRIPTION="As of JET 13.0.0, <oj-selector> no longer generates a default aria-labelledby attribute for a screen reader. "+"Applications must specify an aria-labelledby or aria-label attribute explicitly.";const SHORT_DESCRIPTION="Applications must specify an aria-labelledby/aria-label attribute explicitly on <oj-selector.";const ARIA_LABELLEDBY="aria-labelledby";const ARIA_LABEL="aria-label";const COLON=":";class Rule{getName(){return RULENAME}getDescription(){return DESCRIPTION}getShortDescription(){return SHORT_DESCRIPTION}register(){return{"<oj-selector>":this._onOjSelector}}_onOjSelector(ruleCtx){var attrs,attr;attrs=ruleCtx.tagNode.attribs;for(attr in attrs){if(attr.charAt(0)===COLON){attr=attr.substring(1)}if(attr===ARIA_LABELLEDBY||attr===ARIA_LABEL){return}}let issue=new ruleCtx.Issue("Missing attribute 'aria-labelledby' on <oj-selector>");ruleCtx.reporter.addIssue(issue,ruleCtx)}}module.exports=Rule;