/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const RULENAME="oj-acc-button-onclick";const DESCRIPTION="The ojAction event should be used in place of ojClick for button-like components, because it is triggered by both mouse and keyboard.";const SHORT_DESCRIPTION="The ojAction event should be used in place of ojClick for button-like components.";class Rule{getName(){return RULENAME}getDescription(){return DESCRIPTION}getShortDescription(){return SHORT_DESCRIPTION}register(){return{"<oj-action-card on-click=>":this._onBtn,"<oj-button on-click=>":this._onBtn,"<oj-menu-button on-click=>":this._onBtn,"<oj-c-button on-click=>":this._onBtn,"<oj-c-split-menu-button on-click=>":this._onBtn}}_onBtn(ruleCtx){var issue=new ruleCtx.Issue(`<${ruleCtx.tag}> 'on-click' event attribute - replace with 'on-oj-action'`);ruleCtx.reporter.addIssue(issue,ruleCtx)}}module.exports=Rule;