/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const RULE_NAME="oj-html-5-tag-obs";function getName(){return RULE_NAME};function getShortDescription(){return"HTML5 obsolete elements must not be used"};function getDescription(){return"HTML5 obsolete elements must not be used."};function register(){return{"tag":_handleTag}};function _handleTag(ruleCtx,tagName){if(ruleCtx.utils.DomUtils.isHtml5ObsoleteElem(tagName)){var issue=new ruleCtx.Issue("Element <"+tagName+"> is obsolete in HTML5");ruleCtx.reporter.addIssue(issue,ruleCtx)}};module.exports={getName,getDescription,getShortDescription,register};