/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const RULE_NAME="oj-html-ojattr-evt-syntax";function getName(){return RULE_NAME};function getShortDescription(){return"Web component event listener attributes should not use {{...}} notation"};function getDescription(){return"A web component event listener attribute cannot use '{{ . . . }}' notation because writeback is inapplicable.  Use '[[. . .]]' notation."+"<p>For example, change:<br>"+"  <oj-accordion on-oj-before-collapse='{{listener}}'></oj-accordion><br> "+"to:<br>"+"  <oj-accordion on-oj-before-collapse='[[listener]]'></oj-accordion><br>"};function register(){return{"event":_handleEvent}};function _handleEvent(ruleCtx,evtName,evtValue){if(evtValue.startsWith("{{")){let issue=new ruleCtx.Issue("Event attribute '"+evtName+"' cannot use writeback notation - replace with [[...]]");ruleCtx.reporter.addIssue(issue,ruleCtx)}};module.exports={getName,getDescription,getShortDescription,register};