/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const RULE_NAME="oj-html-ojslot";function getName(){return RULE_NAME};function getShortDescription(){return"<oj-bind-slot> should be used instead of deprecated <oj-slot>"};function getDescription(){return"<i><oj-slot></i> has been <b>deprecated</b> since it is a binding-only element, and not a full custom "+"element with properties and methods that can be accessed. Replace with <i><oj-bind-slot></i>."};function register(){return{"<oj-slot>":function(ruleCtx){var issue=new ruleCtx.Issue("<oj-slot> is deprecated. Use <oj-bind-slot>.");ruleCtx.reporter.addIssue(issue,ruleCtx)}}};module.exports={getName,getDescription,getShortDescription,register};