/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const RULENAME="oj-html-rating-gauge-track-resize";const DESCRIPTION="The use of the <oj-rating-gauge> 'track-resize' attribute is a Redwood theme anti-pattern. "+"This attribute is only needed if the 'size' attribute is set to 'fit', however, 'fit' is a "+"Redwood theme anti-pattern.";const SHORT_DESCRIPTION="Do not use <oj-rating-gauge> with the 'track-resize' attribute set to 'on' in Redwood";class Rule{getName(){return RULENAME}getDescription(){return DESCRIPTION}getShortDescription(){return SHORT_DESCRIPTION}register(){return{"<oj-rating-gauge track-resize=>":this._onTrackResize}}_onTrackResize(ruleCtx,attr,value){if(value==="on"){let issue=new ruleCtx.Issue(`<oj-rating-gauge> attribute 'track-size' value 'on' is an anti-pattern in Redwood.`);issue.setSeverity("blocker");ruleCtx.reporter.addIssue(issue,ruleCtx)}}}module.exports=Rule;