/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const RULENAME="oj-html-tabbar-edge";const DESCRIPTION="Vertical support in <oj-tab-bar> is deprecated in JET 15.0.0 (use <oj-navigation-list> instead). "+"Use of 'edge' property values 'start' or 'end' (or omitting 'edge') is not recommended, and the values 'top' or 'bottom' should be used.";const SHORT="Vertical support in <oj-tab-bar> is deprecated in JET 15.0.0, use 'edge' property values 'top' or 'bottom'";const EDGE="edge";const START="start";const END="end";const MSG_NOEDGE="Vertical support is deprecated (JET 15.0.0) : 'edge' property default value is 'start'. Specify 'top' or 'bottom'. <oj-navigation-list> is suggested for vertical layout.";const MSG_EDGE_START="The 'start' value for 'edge' attribute is not recommended (as of JET 15.0.0). Specify 'top' or 'bottom'.  Specify 'top' or 'bottom'. <oj-navigation-list> is suggested for vertical layout.";class Rule{getName(){return RULENAME}getDescription(){return DESCRIPTION}getShortDescription(){return SHORT}register(){return{"<oj-tab-bar>":this._onTabBar}}_onTabBar(ruleCtx){var edge=ruleCtx.tagNode?.attribs[EDGE];if(!edge){ruleCtx.reporter.addIssue(new ruleCtx.Issue(MSG_NOEDGE),ruleCtx)}else if(edge===START){let issue=new ruleCtx.Issue(MSG_EDGE_START);let attrPos=ruleCtx.utils.DomUtils.getAttribPosition(ruleCtx.data,ruleCtx.node,EDGE);issue.setPosition(attrPos.row,attrPos.col,attrPos.start,attrPos.end);issue.setMsgKey(RULENAME+"_1");ruleCtx.reporter.addIssue(issue,ruleCtx)}}}module.exports=Rule;