/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const RULE="oj-tsx-databind-all";const HELP="A 'data-bind' property has been found!  Knockout is not included, and should not be used, in a Virtual DOM (VDOM) architecture based application.  "+"The use of State and Properties should be used in place of Knockout.";const DATA_BIND="data-bind";function getName(){return RULE}function getShortDescription(){return HELP}function getDescription(){return HELP}function register(){return{TsxComponent:function(ruleCtx,tsxComp){let tsxProp;if(tsxProp=ruleCtx.utils.tsxUtils.getProperty(tsxComp,DATA_BIND)){let issue=new ruleCtx.Issue(`'data-bind' property found on <${tsxComp.name}> - remove.`);ruleCtx.utils.tsxUtils.setIssuePosition(issue,tsxProp);ruleCtx.reporter.addIssue(issue,ruleCtx)}}}}module.exports={getName,getDescription,getShortDescription,register};