/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const RULE_NAME="oj-html-label-for-prefix";const SHORT_DESCRIPT="<oj-label> 'for' attributes should not be prefixed with a ':'";const LONG_DESCRIPT="The <oj-label> 'for' attribute should not be prefixed with a ':'.  The 'for' attribute is an explicit property of <oj-label> and is not a global attribute.";const COLON_FOR=":for";function getName(){return RULE_NAME};function getShortDescription(){return SHORT_DESCRIPT};function getDescription(){return LONG_DESCRIPT};function register(){return{"ojtag":_handle}}function _handle(ruleCtx,tagName){var attribs,attrPos,issue,attrPos;if(tagName!=="oj-label"||ruleCtx.filepath.includes("jet-composites")||!ruleCtx.tagNode.attribs){return}attribs=ruleCtx.tagNode.attribs;if(attribs.hasOwnProperty(COLON_FOR)){issue=new ruleCtx.Issue(`<${ruleCtx.tag}> ':for' should be unprefixed`);attrPos=ruleCtx.utils.DomUtils.getAttribPosition(ruleCtx.data,ruleCtx.node,COLON_FOR);issue.setPosition(attrPos.row,attrPos.col,attrPos.start,attrPos.end);ruleCtx.reporter.addIssue(issue,ruleCtx)}};module.exports={getName,getDescription,getShortDescription,register};