/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const RULE_NAME="oj-html-ojtag-datactx";function getName(){return RULE_NAME};function getShortDescription(){return"Attribute 'data-oj-context' should not specify an expression"};function getDescription(){return"Use of an attribute expression for 'data-oj-context' is meaningless"};function register(){return{"<data-oj-context=>":_handleAttr}};function _handleAttr(ruleCtx,attrName,attrValue){if(_isExpr(attrValue)){let issue=new ruleCtx.Issue("'data-oj-context' attribute expession not expected");ruleCtx.reporter.addIssue(issue,ruleCtx)}};function _isExpr(s){return s.startsWith("[[")||s.startsWith("{{")}module.exports={getName,getDescription,getShortDescription,register};