/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const RULENAME="oj-html-public-api";const DESCRIPTION="Components marked 'packPrivate' are not intended for public use and should not be used.";const SHORT_DESCRIPTION="short description";class Rule{getName(){return RULENAME}getDescription(){return DESCRIPTION}getShortDescription(){return SHORT_DESCRIPTION}register(regCtx){this._metaLib=regCtx.utils.metaLib;return{"webcomp":this._onComponent}}_onComponent(ruleCtx,tagName){if(this._metaLib.isTagPackPrivate(tagName)){this._emitIssue(ruleCtx,tagName)}}_emitIssue(ruleCtx,tagName){var issue,meta,pack;meta=this._metaLib.getTagMetadata(tagName);pack=meta.pack?` (in pack '${meta.pack}')`:"";issue=new ruleCtx.Issue(`<${tagName}>${pack} is 'packPrivate' and is not intended for public use.`);ruleCtx.reporter.addIssue(issue,ruleCtx)}}module.exports=Rule;