/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const RULENAME="oj-html-wctag-packprivate";const DESCRIPTION="Components marked as 'packPrivate' in their component.json metadata, are private base classes "+"that can be extended by other classes in the same pack. They cannot be used as application "+"'stand-alone' components.";const SHORT_DESCRIPTION="'packPrivate' components cannot be used as application 'stand-alone' components.";class Rule{getName(){return RULENAME}getDescription(){return DESCRIPTION}getShortDescription(){return SHORT_DESCRIPTION}register(){return{webcomp:this._onWebComp}}_onWebComp(ruleCtx,tag){if(ruleCtx.utils.metaLib.isTagPackPrivate(tag)){let issue=new ruleCtx.Issue(`<${tag}> is not intended for stand-alone use in an application`);ruleCtx.reporter.addIssue(issue,ruleCtx)}}}module.exports=Rule;