/*
 * Copyright (c) 2018, 2025, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 */
const RULE_NAME="oj-json-syntax";function getName(){return RULE_NAME};function getShortDescription(){return"JSON syntax must be valid"};function getDescription(){return"The contents of a JSON file must be syntactically valid, and produce no parse errors."};function register(){return{"file":function(context){if(context.filepath.indexOf("component.json")>=0){return true}if(context.suppData.msg){var issue;issue=new context.Issue(context.suppData.msg);issue.setPosition(context.suppData.line,context.suppData.col);context.reporter.addIssue(issue,context);return false}}}};module.exports={getName,getDescription,getShortDescription,register};